/*
Autor solutie: Verestiuc Daniel-Silviu
Unitate de invatamant: Scoala Gimnaziala `George Calinescu` - Iasi

Descriere solutie:
- Citesc numarul natural `n` care reprezinta cate pisici participa la concurs.
- Dupa citirea numarului de pisici se citesc, pe rand, varstele individuale ale pisicilor si se calculeaza varsta minima.
- Dupa determinarea varstei minime vom calcula varsta `in ani umani` conform conditiilor, apoi impartim la 10 si aflam numarul culoarului
    - daca pisica are 1 an calendaristic, varsta in ani umani este de 15, deci defileaza pe culoarul 1
    - daca pisica are 2 sau mai multi ani calendaristici, atunci utilizam formula `24 + (x - 2) * 4`
            - 24 - varsta daca are 2 ani calendaristici
            - la aceasta varsta adaugam (n-2)*4 ani
*/


#include <fstream>

using namespace std;

int main()
{
    unsigned long long int n, i;
    unsigned short int x, min=100;
    ifstream fisier_in;
    ofstream fisier_out;

    fisier_in.open("catshow.in");
    fisier_out.open("catshow.out");

    // Veriifcam daca fisierele au fost deschise corespunzator si oprim executia programului in caz contrar
    if(!fisier_in){
        //cout << "Fisierul de intrare nu a putut fi deschis cu succes.";
        return 0;
    }
    if(!fisier_out){
        //cout << "Fisierul de iesire nu a putut fi deschis cu succes.";
        return 0;
    }

    // Citim numarul de pisici participante la competitie
    fisier_in >> n;

    // Citim varstele celor 'n' pisici si determinam varsta minima
    for(i=0; i<n; i++){
        // Citim urmatoarea varsta
        fisier_in >> x;

        // verificam daca varsta este mai mica decat minimul curent
        // si actualizam in caz afirmativ.
        if(x < min){
            min = x;
        }
    }

    // Calculam valoarea culoarului in functie de varsta minima
    if(min == 1){
        // daca pisica are un an, atunci va defila pe culoarul 1 (15/10=1)
        //cout << 1;
        fisier_out <<1;
    } else {
        // calculam varsta pisicii in ani omenesti conform formulei `24 + (min - 2) * 4`
        // apoi aflam culoarul pe care defileaza aceasta
        fisier_out << (24 + (min - 2)  * 4) / 10<< endl;
    }

    // Inchidem fisierele
    fisier_in.close();
    fisier_out.close();
    return 0;
}
