#include <fstream>

using namespace std;

ifstream fin("institut.in");
ofstream fout("institut.out");

int c;      // cerinta
int n;      // numarul de santiere arheologice, maxim 400

int main()
{
    fin >> c;
    fin >> n;

//          CERINTA 1           //

    if (c==1)
    {
        struct categoria
        {
            int material[100];      // material
            int numarEx;            // numar de exemplare
        }catg[100]={0};             // categoria, cel mult 2 cifre

        int nrV;        // numarul de valori pentru fiecare santier, maxim 600
        int i, j;

        int Ct, mt;
        int NrExemplare;
        int nrNg;

        for(i=1; i<=n; i++) // parcurg fiecare santier
        {
            fin >> nrV;
            for(j=1; j<=nrV; j=j+3) // prelucrez (categorie, material, numar exemplare)
            {
                fin >> Ct;
                fin >> mt;

                fin >> NrExemplare;
                if (NrExemplare < 0)
                    catg[Ct].numarEx += 1;
                else
                {
                    catg[Ct].numarEx += NrExemplare;

                    // sar peste numarul negativ
                    fin >> nrNg;
                    j++;
                }
            }
        }

        // afisare dupa categorie, apoi afisarea numarului total de obiecte descoperite la acea categorie

        for(i=0; i<100; i++)
            if (catg[i].numarEx != 0)
                fout << i << ' ' << catg[i].numarEx << '\n';
    }

//          CERINTA 2           //

    if (c==2)
    {
        struct categoria
        {
            int material_nrEx[100][2];   // material si numar de exemplare
        }catg[100]={0};                  // categoria, cel mult 2 cifre

        int nrV;        // numarul de valori pentru fiecare santier, maxim 600
        int i, j;

        int descoperiri=0;

        int Ct, mt;
        int NrExemplare;
        int nrNg;

        for(i=1; i<=n; i++) // parcurg fiecare santier
        {
            fin >> nrV;
            for(j=1; j<=nrV; j=j+3) // prelucrez (categorie, material, numar exemplare)
            {
                descoperiri++;

                fin >> Ct;
                fin >> mt;

                catg[Ct].material_nrEx[mt][0]=mt;


                fin >> NrExemplare;
                if (NrExemplare < 0)
                    catg[Ct].material_nrEx[mt][1]=1;
                else
                {
                    catg[Ct].material_nrEx[mt][1]=NrExemplare;

                    // sar peste numarul negativ
                    fin >> nrNg;
                    j++;
                }
            }
        }

        fout << descoperiri << '\n';

        for(i=0; i<100; i++)
            for(j=0; j<100; j++)
                 if (catg[i].material_nrEx[j][0] != 0)
                    fout << i << ' ' << catg[i].material_nrEx[j][0] << ' ' << catg[i].material_nrEx[j][1] << '\n';

    }

    return 0;
}
