#include <iostream>
#include <fstream>
using namespace std;

ifstream fin("pase.in");
ofstream fout("pase.out");
int N;
void cautaSolutie(int N, const char S[]) {
    int max_length = 0, start_index = 0;

    // Parcurgem toate pozițiile posibile
    for (int i = 0; i < N; ++i) {
        int greseli = 0; // Numărăm greșelile în subșirul curent
        for (int j = i; j < N; ++j) {
            if (S[j] == 'G') greseli++;

            // Dacă am depășit limita de 2 greșeli, ne oprim
            if (greseli > 2) break;

            // Calculăm lungimea subșirului curent și actualizăm rezultatul maxim
            int current_length = j - i + 1;
            if (current_length > max_length) {
                max_length = current_length;
                start_index = i;
            }
        }
    }

    // Afișăm lungimea maximă și indicele de început
    fout << max_length << " " << start_index + 1 << endl;
}

int main() {
    const int MAX_N = 1000; // Dimensiunea maximă a șirului
    char S[MAX_N + 1];      // Șirul de caractere
    fin>>N;
    fin >> S;               // Citim șirul de caractere


    cautaSolutie(N, S);
    return 0;
}
