#include <iostream>
#include <fstream>
using namespace std;

int main() {
    ifstream fin("catshow.in");
    ofstream fout("catshow.out");

    int n;
    fin >> n;

    int minLane = INT_MAX; // Inițializăm culoarul minim cu o valoare mare

    for (int i = 0; i < n; i++) {
        int catAge;
        fin >> catAge;

        // Calculăm vârsta în ani umani
        int humanAge = 0;
        if (catAge == 1) {
            humanAge = 15;
        } else if (catAge == 2) {
            humanAge = 24;
        } else if (catAge > 2) {
            humanAge = 24 + (catAge - 2) * 4;
        }

        // Calculăm culoarul
        int lane = humanAge / 10;

        // Actualizăm culoarul minim
        if (lane < minLane) {
            minLane = lane;
        }
    }

    // Scriem culoarul minim în fișier
    fout << minLane << "\n";

    fin.close();
    fout.close();

    return 0;
}
