//Serban Marinel
#include <bits/stdc++.h>
#include <cstring>

using namespace std;

ifstream fin("plasmopara.in");
ofstream fout("plasmopara.out");

char V[205][205];
int n, m, z, cate, C, zi_max, care_zi;

void citire_bordare()
{
   int i, j;
   fin >> C;
   fin >> n >> m >> z;
   fin.get();
   for (i = 1; i <= n; i++)
   {
      for (j = 1; j <= m; j++)
         fin >> V[i][j];
      fin.get();
   }
   for (i = 0; i <= n + 1; i++)
      V[i][0] = V[i][m+1] = 'N';
   for (j = 0; j <= m + 1; j++)
      V[0][j] = V[n+1][j] = 'N';
}

void afisare()
{
   int i, j;
   for (i = 1; i <= n; i++)
   {
      for (j = 1; j <= m; j++)
         fout << V[i][j];
      fout << '\n';
   }
   fout << '\n';
}

void umple()
{
   struct coada
   {
      short l, c;
   } C1[500], C2[500], X;
   short dl[] = {-1, 0, 1, 0}, dc[] = {0, 1, 0, -1};
   short l9, c9, k, ziua;
   short ic1 = 0, sc1 = -1, ic2, sc2;
   if (V[1][1] == '-')               //pun in coada C1 1,1
   {
      V[1][1] = '*'; C1[++sc1].l = 1; C1[sc1].c = 1;
   }
   if (V[1][m] == '-')               //pun in coada C1 1,m
   {
      V[1][m] = '*'; C1[++sc1].l = 1; C1[sc1].c = m;
   }
   if (V[n][1] == '-')               //pun in coada C1 n,1
   {
      V[n][1] = '*'; C1[++sc1].l = n; C1[sc1].c = 1;
   }
   if (V[n][m] == '-')               //pun in coada C1 n,m
   {
      V[n][m] = '*'; C1[++sc1].l = n; C1[sc1].c = m;
   }
   if (sc1 > zi_max)
   {
      zi_max = sc1; care_zi = 1;    //initial afectati si ziua
   }
   ziua = 2;
   while (ziua <= z)
   {
      ic2 = 0; sc2 = -1;      //pregatesc C2
      while (ic1 <= sc1)            //parcurg C1
      {
         X = C1[ic1++];
         for (k = 0; k < 4; k++)
         {
            l9 = X.l + dl[k];
            c9 = X.c + dc[k];
            if (V[l9][c9] == '-') //pozitie afectata
            {
               V[l9][c9] = '*';  //o sterg
               C2[++sc2].l = l9;
               C2[sc2].c = c9; //pun in C2 pozitia afectata
            }
         }
      }
      if (sc2 > zi_max)             //mai multi afectati
      {
         zi_max = sc2;
         care_zi = ziua;
      }
      ziua++;                       //a mai trecut o zi
      memcpy(C1, C2, sizeof(C2));   //copiez C2 in C1 pentru ziua urmatoare
      ic1 = 0; sc1 = sc2;
   }
}

int numara()
{
   int i, j, k = 0;
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
         if (V[i][j] == '-') k++;
   return k;
}
int main()
{
   citire_bordare();                 //citire-bordare
   umple();                          //descrie procesul de afectare zilnica
   if (C == 1)                       //cerinta 1
   {
      cate = numara();              //numar ce a ramas
      fout << cate << '\n';         //afisez rezultatul
   }
   else                              //cerinta 2
      fout << care_zi << '\n';
   return 0;
}
