//Em. Cerchez 100 de puncte

#include <fstream>
#include <vector>
#define NMAX 100001
using namespace std;
ifstream fin("raspandaci.in");
ofstream fout("raspandaci.out");
int n, nrc, poz=1, rez;
vector<int> G[NMAX];
vector<int> GT[NMAX];
int postordine[NMAX];
int CTC[NMAX]; //CTC[i]= numarul componentei tare-conexe din care face parte i
int d[NMAX];   //d[i] =numarul arcelor care au ca extremitate finala un varf din ctc i
bool viz[NMAX];

void citire();
void determina_d();
void DFS(int x);
void DFST(int x);
bool cauta(int x, int y)
{int i;
 for (i=0; i<G[x].size(); i++)
     if (y==G[x][i]) return 1;
 return 0;
}
int main()
{int i, j;
 citire();
 for (i=1; i<=n; i++)
     if (!viz[i]) DFS(i);
 for (i=n; i>=1; i--)
     if (viz[postordine[i]]==1) //adica acest vf este nevizitat in graful transpus
         {nrc++; DFST(postordine[i]);}

 determina_d();

 for (i=1; i<=nrc; i++)
     if (d[i]==0)
         {rez++;
          //fout<<i<<' ';
         }
 
 fout<<rez<<'\n';
 return 0;
}

void citire()
{int i, m=0, x, y;
 fin>>n;
 while (fin>>x>>y)
       {m++;
        if (cauta(x,y)) fout<<x<<' '<<y<<'\n';
            else
            G[x].push_back(y);
        GT[y].push_back(x);
       }
}

void DFS(int x)
{int i;
 viz[x]=1;
 //parcurg lista de adiacenta a lui x
 for (i=0; i<G[x].size(); i++)
     if (!viz[G[x][i]])
        DFS(G[x][i]);
 postordine[poz++]=x;
}

void DFST(int x)
{ int i;
  viz[x]=0; CTC[x]=nrc;
  for (i=0; i<GT[x].size(); i++)
     if (viz[GT[x][i]])
        DFST(GT[x][i]);
}

void determina_d()
{int i, j;
 for (i=1; i<=n; i++)
    for (j=0; j<G[i].size(); j++)
        if (CTC[i]!=CTC[G[i][j]])
           d[CTC[G[i][j]]]++;
}
